
##           BLENDERWORLD V0.1
##                      Sript de modlisation de terrains

##--INSTALLATION--######################################
########################################################
## 1) Avant de demarrer ce script, remplissez         ## 
## cette ligne avec le chemin ou vous avez            ## 
## installe BlenderWorld:                             ##
########################################################
########################################################

# dir='/Blender/python/blenderworld/'     #Linux

dir='e:\\Blender\\python\\blenderworld\\' #Windows

##--INSTALLATION (suite)--##############################
########################################################
## 2) Faites Alt-S                                    ##
## 3) Puis faites Alt-P                               ##
## Pour tout autre probleme utilisez la rubrique Aide ##
########################################################
########################################################

##--LANCEMENT--#########################################
########################################################
##     ###      ##     ########         #####         ##
##    ## ##     ##        ##            ## ##         ##
##   ##   ##    ##        ##    #####   ####          ##
##  #########   ##        ##    #####   ##            ##
## ##       ##  #####     ##            ##            ##
########################################################
########################################################


## ET HAPPY BLENDING A TOUT LE MONDE ###################
########################################################

##--declarations--######################################
########################################################
import Blender
import sys
from Blender import NMesh
from Blender.Draw import *
from Blender.BGL import *
import math
from math import *

##--traitement des images--#############################
########################################################
## Remerciement a JM car le script pour afficher les  ##
## images est de lui.                                 ##
########################################################
########################################################

loc=dir+'logo.tga'
loc2=dir+'la.tga'
loc3=dir+'noz.tga'

def read_tgafile(loc):
    width=0
    height=0
    f=open(loc,'rb')
    ee=f.read(18);
    width=ord(ee[13])*256+ord(ee[12])
    height=ord(ee[15])*256+ord(ee[14])
    ee=f.read()
    f.close()
    n=0
    bitmap= Buffer(GL_BYTE, ( height, width, 4))
    for y in range(height-1,0,-1):
        for x in range(0, width):
            bitmap[y][x][2]= ord(ee[n]); n=n+1
            bitmap[y][x][1]= ord(ee[n]); n=n+1
            bitmap[y][x][0]= ord(ee[n]); n=n+1
    return bitmap,width,height

bitmap,width, height=read_tgafile(loc)
bitmap2,width2, height2=read_tgafile(loc2)
bitmap3,width3, height3=read_tgafile(loc3)



##--Les declarations--##################################
########################################################

menuy= Create(100)
ndefx = Create(50)
ndefy = Create(50)
Tog = Create(0)
Togi = Create(0)

wsize = Buffer(GL_INT, 4) 
glGetIntegerv(GL_VIEWPORT, wsize)
Sposb= [wsize[0], wsize[1]]

Spos = [0.0, 0.0]
tpin = Create(3)
Vop  = Create(10)
Posx = 115
Posy = 13
Sisx = 300
Sisy = 300
Clig = 0
Clid = 0
fpin=(Vop.val*1.00)/100
lk=0
rk=0
uk=0
dk=0
sk=0
ini=0



##--Modul de modelisation--#############################
########################################################
#nump=[0.0, 0.0, 0.0, 0.0]
#def num(nump):
#    return (MouseCo[0]-(si/2)),(MouseCo[1]-(si/2)),(MouseCo[0]+(si/2)),(MouseCo[1]+(si/2))

##--Creation de base de donnee--########################
########################################################

Defx = ndefy.val
Defy = ndefy.val
Sipx=((Sisx*1.0)/(Defx*1.0))
Sipy=((Sisy*1.0)/(Defy*1.0))
print Sipx,Sipy
Map=[]
Vbx=0
Vby=0
ini=0
while Vbx <= Defx:
    Cont=[Vbx,Vby,0.0]
    Map.append(Cont)
    while Vby <= Defy-1:
        Cont=[Vbx,Vby+1,0.0]
        Map.append(Cont)
        Vby=Vby+1
    Vby=0
    Vbx=Vbx+1


##--Les tooltips--######################################
##--(ce qui s'affiche quand on passe sur un bouton)--###

tooltips={}
tooltips['m1']='Vraiment ?'
tooltips['m2']='Info'
tooltips['m3']="Besoin d'aide ?"
tooltips['m4']='Remerciements'
tooltips['m5']='Comment me contacter'
tooltips['hm']='Pour sortir de ce module'

tooltips['O1']='Modeliser un terrain'
tooltips['O2']='Option du terrain'
tooltips['O3']='Creation de la base de donnee du terrain'
tooltips['O4']='Tracer le terrain'
tooltips['O5']='Recommencer le terrain'
tooltips['O6']='Saisie de la souris'
tooltips['O7']='Lissage du terrain'
tooltips['O8']='Taille du pinceau'
tooltips['O9']='Force de trait'
tooltips['OA']='Pinceau inverse'
tooltips['in']='Detection souris'

print"ICI S'AFFICHERONT LES ERREURS"

#Pour aller plus vite
glc=glColor3f
gla=glColor4f
glr=glRecti


def draw(): 
    global menuym, ndefx, ndefy, Tog, tpin, Vop, Togi, ini, wsize


        
    if menuy.val != 7 or ini!=0:
        glClearColor(0, 0, 0, 0.0) 

        glClear(GL_COLOR_BUFFER_BIT) 
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
        glRasterPos2i(10, 400)
        glDrawPixels (width, height, GL_RGBA, GL_UNSIGNED_BYTE, bitmap)
        glRasterPos2i(50, 250)
        glDrawPixels (width2, height2, GL_RGBA, GL_UNSIGNED_BYTE, bitmap2)

        glRasterPos2i(150, 140)
        glDrawPixels (width3, height3, GL_RGBA, GL_UNSIGNED_BYTE, bitmap3)
        print 're'
        glc(1,1,1)
        glr(220,340,600,350)
        if wsize[0]>30: 
            glr(86,0,96,251)
            glc(0.6,0.6,0.6)
            glr(95,0,600,251)
        else:
            glr(87,0,96,251)
            glc(0.6,0.6,0.6)
            glr(96,0,600,251)            
        glr(220,340,600,250)

        glc(0.6,0.6,0.6)
        glr(119,140,179,141)
        glc(0.4,0.4,1.0)
        glRasterPos2d(390, 410)
        Text("V0.1")
        if ini==1:
            ini=0
            bevent(7)


    if menuy.val== 100:
        glc(0,0,0)
        glRasterPos2d(180, 160)
        Text("NOZ Presente BlenderWorld")
        glRasterPos2d(180, 140)
        Text("Le Modeleur de terrain pour BLENDER")
        glRasterPos2i(150, 140)
        glDrawPixels (width3, height3, GL_RGBA, GL_UNSIGNED_BYTE, bitmap3)
        glc(0.6,0.6,0.6)
        glr(119,140,179,141)

    


    Button("Quitter", 9, 340, 360, 80, 20, tooltips['m1'])
    Button("Info", 2, 20, 360, 80, 20, tooltips['m2'])
    Button("Aide", 3, 100, 360, 80, 20, tooltips['m3'])
    Button("Credits", 4, 180, 360, 80, 20, tooltips['m4'])
    Button("Contact", 5, 260, 360, 80, 20, tooltips['m5'])

    if menuy.val != 100 and menuy.val != 7: Button("Sortir", 6, 360, 10, 70, 19, tooltips['hm']) 
    Button("Modelisation", 7, 2.5, 210, 80, 20, tooltips['O1'])
    Button("Options", 8, 2.5, 245, 80, 20, tooltips['O2'])

    if menuy.val== 7:
        Button("Tracer", 10, 2.5, 10, 80, 20, tooltips['O4'])
        Button("Effacer", 11, 2.5, 45, 80, 20, tooltips['O5'])
        tpin= Number("Taille : ", 100, 2.5, 80, 80, 20, tpin.val, 1, 10, tooltips['O8'])
        Vop= Number("Force", 1, 2.5, 115, 80, 20, Vop.val, 1, 20, tooltips['O9'])
        Togi=Toggle("Inverse", 14, 2.5, 150, 80, 20,Togi.val, tooltips['OA'])
        glc(0.9,0.9,0.9)
        glr(10,185,70,190)
 
    glc(0.0,0.0,0.3)
    if menuy.val ==8: 
        glRasterPos2f(230, 270) 
        Text("Options:")
        glRasterPos2f(120, 230) 
        Text("Definition du terrain:")

        ndefy= Number("X : ", 100, 300, 200, 80, 19, ndefy.val, 10, 100)
        ndefy= Number("Y : ", 100, 200, 200, 80, 19, ndefy.val, 10, 100)
        Button("Creation", 13, 110, 10, 80, 20, tooltips['O3'])
        Tog=Toggle("Lissage", 100, 300, 70, 80, 20,Tog.val, tooltips['O7'])
        Button("Saisie", 20, 300, 140, 80, 20, tooltips['O6'])

        glRasterPos2f(120, 170) 
        Text("Saisie des informations de la souris:") 
        glRasterPos2f(120, 100) 
        Text("Lissage du terrain:") 


    if menuy.val ==2: 
        glRasterPos2f(230, 270) 
        Text("Infos:")
        glRasterPos2f(120, 230) 
        Text("Dans les prochaines versions de BlenderWorld")
        glRasterPos2f(120, 210) 
        Text("sera integre :")
        glRasterPos2f(120, 190) 
        Text("Modelisation :")
        glRasterPos2f(120, 170) 
        Text("--> Application de vertex colors")
        glRasterPos2f(120, 150) 
        Text("--> Modelisation aleatoire")
        glRasterPos2f(120, 130) 
        Text("--> Pinceaux speciaux")
        glRasterPos2f(120, 110) 

    if menuy.val ==3: 
        glRasterPos2f(230, 270) 
        Text("Aide:")
        glRasterPos2f(120, 230) 
        Text("")
        glRasterPos2f(120, 210) 
        Text("")
        glRasterPos2f(120, 180) 
        Text("")
        glRasterPos2f(120, 160) 
        Text("")
        glRasterPos2f(120, 140) 
        Text("")
        glRasterPos2f(120, 120) 
        Text("")
        glRasterPos2f(120, 90) 
        Text("")
        glRasterPos2f(120, 70) 
        Text("")
    if menuy.val ==4:
        glRasterPos2f(230, 270) 
        Text("Remerciments:")
        glRasterPos2f(120, 230) 
        Text("")
        glRasterPos2f(120, 210) 
        Text("")
        glRasterPos2f(120, 180) 
        Text("")
        glRasterPos2f(120, 160) 
        Text("")
        glRasterPos2f(120, 130) 
        Text("")
        glRasterPos2f(120, 110) 
        Text("")
    if menuy.val ==5:
        glc(0.6,0.1,0.1)
        glRasterPos2f(230, 270) 
        Text("Contact:")
        glc(1,1,1)
        glRasterPos2f(175, 230) 
        Text("Si vous voulez me contacter:")
        glRasterPos2f(195, 200) 
        Text("noz.mai@caramail.com")
        glRasterPos2i(250, 120)
        glDrawPixels (width3, height3, GL_RGBA, GL_UNSIGNED_BYTE, bitmap3)
        glc(0.6,0.6,0.6)
        glr(241,120,280,121)




def event(evt, val):
    global Map, Defx, Defy, Posx, Posy, Sisx, Sisy, Spos, Sipx, Sipy, menuy, ini, Clig, Clid, tpin, Vop, mdef, fpin, lk, rk, dk, uk, sk, Togi, Sposb, wsize, Tog,v1,v2,v3,v4,v5,v6
    if (evt== QKEY): Exit()
    dX = 0
    dY = 0
    Np = 0
    if Togi.val==1:
        fpin=(Vop.val*(-1.00))/100
    else:
        fpin=(Vop.val*1.00)/100


    if evt == MOUSEX:
        dX = val - Spos[0]
        Spos[0] = val



    if evt == MOUSEY:
        dY = val - Spos[1]
        Spos[1] = val 

    if (evt == LEFTMOUSE and Spos[0] - Sposb[0] > Posx and Spos[0] - Sposb[0] < Posx+Sisx and Spos[1] - Sposb[1] > Posy and Spos[1] - Sposb[1] < Posy+Sisy and menuy.val == 7):
        if Clig==0:
            Clig=1
            v1=((tpin.val-1)*Sipx)
            v3=Sipx+((tpin.val-1)*Sipx)
            v5=((tpin.val-1)*Sipy)
            v6=Sipy+((tpin.val-1)*Sipy)
        else:
            Clig=0
 

    if (evt == RIGHTMOUSE and Spos[0] - Sposb[0] > Posx and Spos[0] - Sposb[0] < Posx+Sisx and Spos[1] - Sposb[1] > Posy and Spos[1] - Sposb[1] < Posy+Sisy and menuy.val == 7):
        if Clid==0:
            fpin=fpin*(-1)
            if Togi.val==1:
                Togi.val=0
            else:
                Togi.val=1
            Clid=1
        else:
            Clid=0
        Redraw()
    if evt== XKEY:
        Np = 0
        while Np < len(Map):
            Map[Np][2]=0.0
            glc(1.0,1.0,1.0)
            glr(Posx+Sipx*Map[Np][0],Posy+Sipy*Map[Np][1],Posx+Sipx*Map[Np][0]+Sipx,Posy+Sipy*Map[Np][1]+Sipy)
            Np=Np+1
        Draw()

    if evt== LEFTARROWKEY:
        if lk==0 and Vop.val>=2:
            Vop.val=Vop.val-1
            lk=1
        else:
            lk=0
        Draw()
    if evt== RIGHTARROWKEY and Vop.val<=19:
        if rk==0:
            Vop.val=Vop.val+1
            rk=1
        else:
            rk=0
        Draw()
    if evt== UPARROWKEY and tpin.val<=9:
        if uk==0:
            tpin.val=tpin.val+1
            uk=1
        else:
            uk=0
        ini=1
        Draw()
    if evt== DOWNARROWKEY and tpin.val>=2:
        if dk==0:
            tpin.val=tpin.val-1
            dk=1
        else:
            dk=0
        Draw()
    if evt== RKEY:
        ini=1
        wsize = Buffer(GL_INT, 4) 
        glGetIntegerv(GL_VIEWPORT, wsize)
        Sposb= [wsize[0], wsize[1]]
        Draw()
    if evt== SPACEKEY:
        if sk==0:
            bevent(10)
            sk=1
        else:
            sk=0
        Draw()

    if Clig==1:
        for i in Map:
            if (Posx+Sipx*Map[Np][0]-v1 <= Spos[0] - Sposb[0] <= Posx+Sipx*Map[Np][0]+v3 and Posy+Sipy*Map[Np][1]-v5 <=  Spos[1] - Sposb[1] <= Posy+Sipy*Map[Np][1]+v6):
                Map[Np][2]=Map[Np][2]+fpin
                if 0 > Map[Np][2]: 
                    Map[Np][2]=0
                elif 1 < Map[Np][2]: 
                    Map[Np][2]=1
                glc(1-(Map[Np][2]),1-(Map[Np][2]),1-(Map[Np][2]))
                glr(Posx+Sipx*Map[Np][0],Posy+Sipy*Map[Np][1],Posx+Sipx*Map[Np][0]+Sipx,Posy+Sipy*Map[Np][1]+Sipy)

            Np=Np+1

        Redraw()



        

def bevent(evt):
    global Map, Defx, Defy, Posx, Posy, Sisx, Sisy, Spos, Sipx, Sipy, menuy, Clig, Clid, tpin, Vop, mdef, fpin, ndefy, ndefx, Togi, ini, Sposb, wsize
    if (evt== 20):
        wsize = Buffer(GL_INT, 4) 
        glGetIntegerv(GL_VIEWPORT, wsize)
        Sposb= [wsize[0], wsize[1]]
        Draw()
    if (evt== 14):
        fpin=fpin*(-1)
        Draw()

        
    if (evt== 13):
        Defx = ndefy.val
        Defy = ndefy.val
        Sipx=((Sisx*1.0)/(Defx*1.0))
        Sipy=((Sisy*1.0)/(Defy*1.0))
        print Sipx,Sipy
        Map=[]
        Vbx=0
        Vby=0

        while Vbx <= Defx:
            Cont=[Vbx,Vby,0.0]
            Map.append(Cont)
            while Vby <= Defy-1:
                Cont=[Vbx,Vby+1,0.0]
                Map.append(Cont)
                Vby=Vby+1
            Vby=0
            Vbx=Vbx+1
        Draw()


    if (evt== 1):
        fpin=(Vop.val*1.00)/100
        Draw()
    if (evt== 8):
        menuy.val=8
        Blender.Redraw()
#Tout effacer
    if (evt== 11):
        Np = 0
        while Np < len(Map):
            Map[Np][2]=0.0
            glc(1.0,1.0,1.0)
            glr(Posx+Sipx*Map[Np][0],Posy+Sipy*Map[Np][1],Posx+Sipx*Map[Np][0]+Sipx,Posy+Sipy*Map[Np][1]+Sipy)
            Np=Np+1
        Draw()
#Quitter
    if (evt== 9):
        sys.stdout.flush()
        Exit()
#Redessine
    if (evt== 100):
        Draw()
#Info
    if (evt== 2):
        menuy.val=2
        Blender.Redraw()
#Aide
    if (evt== 3):
        menuy.val=3
        Blender.Redraw()
#Credits
    if (evt== 4):
        menuy.val=4
        Blender.Redraw()
#Contact
    if (evt== 5):
        menuy.val=5
        Blender.Redraw()
#Sortir
    if (evt== 6):
        menuy.val = 100
        Blender.Redraw()
#Terrain
    if (evt== 7):
        wsize = Buffer(GL_INT, 4) 
        glGetIntegerv(GL_VIEWPORT, wsize)
        Sposb= [wsize[0], wsize[1]]
        glc(0.6,0.6,0.6)
        glr(350,5,450,40)
        glc(0.6,0.6,0.6)
        glr(100,5,200,40)
        Np = 0
        while Np < len(Map):
            glc(1-(Map[Np][2]),1-(Map[Np][2]),1-(Map[Np][2]))
            glr(Posx+Sipx*Map[Np][0],Posy+Sipy*Map[Np][1],Posx+Sipx*Map[Np][0]+Sipx,Posy+Sipy*Map[Np][1]+Sipy)
            Np=Np+1
        menuy.val = 7
        Blender.Redraw()
#Tracer
    if (evt== 10):
        
        me=NMesh.GetRaw()
        try:
            me.has_uvco=0
            me.has_col=0
        except: pass
        Np = 0
        while Np < len(Map):
            v=NMesh.Vert(Map[Np][0]-(Defx/2),Map[Np][1]-(Defy/2),(Map[Np][2]*(Defy/5)))
            me.verts.append(v)
            Np=Np+1

        Np = -1
        while Np < (int(Defx)*int(Defy))+int(Defx):
            Np=Np+1
            if ((Np+1) % ((int(Defx))+1))==0 and Np!=0:
                pass
            else:
                try:
                    f=NMesh.Face()
                    vx=me.verts[Np]
                    f.v.append(vx)
                    vx=me.verts[Np+1]
                    f.v.append(vx)
                    vx=me.verts[Defx+Np+2]
                    f.v.append(vx)
                    vx=me.verts[Defx+Np+1]
                    f.v.append(vx)
                    if Tog.val==1: f.smooth=1
                    me.faces.append(f)
                except:
                    NMesh.PutRaw(me,"Terrain",1)
                    Blender.Redraw()          
            
 


Register(draw, event, bevent) 
sys.stdout.flush()
